<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "provider_payment_type".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ProviderPaymentType".
 *
 * Columns in table "provider_payment_type" available as properties of the model,
 * followed by relations of table "provider_payment_type" available as properties of the model.
 *
 * @property integer $id
 * @property integer $provider_id
 * @property integer $payment_type_id
 *
 * @property Provider $provider
 * @property PaymentType $paymentType
 */
abstract class BaseProviderPaymentType extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'provider_payment_type';
    }

    public static function representingColumn()
    {
        return 'id';
    }

    public function rules()
    {
        return array(
            array('provider_id, payment_type_id', 'required'),
            array('provider_id, payment_type_id', 'numerical', 'integerOnly' => true),
            array('id, provider_id, payment_type_id', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'provider' => array(self::BELONGS_TO, 'Provider', 'provider_id'),
            'paymentType' => array(self::BELONGS_TO, 'PaymentType', 'payment_type_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'provider_id' => Yii::t('app', 'Provider'),
            'payment_type_id' => Yii::t('app', 'Payment Type'),
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->with = array('provider');
        if (!intval($this->provider_id) && is_string($this->provider_id) && strlen($this->provider_id) > 0) {
            $criteria->compare('provider.first_last', $this->provider_id, true);
        } elseif (intval($this->provider_id)) {
            $criteria->compare('provider_id', $this->provider_id);
        }

        $criteria->compare('payment_type_id', $this->payment_type_id);
        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
            'pagination' => array('pageSize' => 100),
        ));
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ProviderPaymentType|ProviderPaymentTypes', $n);
    }

}
